//-------------------------------------------------------------------------
//
// File Name: SM_StateController.as
//
// Copyright (c) 2007-2009, Jason Breti (http://breti.org/codegen)
// All rights reserved.
// This code is released under the BSD License, as specified in the
// license.txt file.
//-------------------------------------------------------------------------

package SM_StateMachine
{
  //-----------------------------------------------------------------------
	// Import Libraries
  //-----------------------------------------------------------------------
  import flash.display.*;
	import flash.utils.Dictionary;

  //-----------------------------------------------------------------------
  public class SM_StateController
  {
		//---------------------------------------------------------------------
		// Public Variables
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Public Constants
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Protected Variables and Constants
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Private Variables and Constants
		//---------------------------------------------------------------------
    private var m_stateChart;

		//---------------------------------------------------------------------
		// Public Methods
		//---------------------------------------------------------------------

		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		// Name: SM_StateController (Constructor)
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    public function SM_StateController ()
    {
			m_stateChart = new SM_StateChart();

    }
		
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		// Name: initialize
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	  public function initialize ():void
		{
			var initialState:SM_State = m_stateChart.initialize();
			
			initialState.onentry();
		}
  
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		// Name: triggerEvent
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	  public function triggerEvent (event:String):void
		{
			var results:Dictionary = m_stateChart.transitionState(event);
			
			if ("transitionFound" in results && results["transitionFound"] == true)
			{
				var nextState:SM_State = results["nextState"];
				
				nextState.onentry();
			}
		}

		//---------------------------------------------------------------------
		// Event Interface Methods
		//---------------------------------------------------------------------
    
		//---------------------------------------------------------------------
		// Protected Methods
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Private Methods
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
  }

}